%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PHY306, Assignment 1, Numerics question template.  IISER Bhopal  2020
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Assignment1

mass = 0.1;
g = 9.81;
length = 0.3;

tfin = 5; 	      %final simulation time
Nsamples = 200;   % number of timesamples
tsamples = linspace(0,tfin,Nsamples);

Ntrajectories = 40;   %how many initial conditions  <<<<< TO EDIT IF NEED BE

%%%%%%%%%%%%%%%%%%%
% trajectory selection

type = 1;  % <<<<< TO EDIT IF NEED BE

if(type==1)

%%%%%% linear range of energies (+/- momenta)
Ecrit= XXX ;  % <<<<< insert the critical energy for which the pendulum goes over the top

Emax = XXX;   % <<<<< choose the maximum energy used in your phase space portrait
dE = Emax/(Ntrajectories/2-1);
Evalues = linspace(dE,Emax,Ntrajectories/2);  %sets up vector of energies

iniphi= zeros(Ntrajectories,1);
inip(1:Ntrajectories/2) = sqrt(2*mass*length*length*Evalues);  % take care of positive and negative directions
inip((Ntrajectories/2+1):Ntrajectories) = -sqrt(2*mass*length*length*Evalues);

elseif(type==2) 

%%%%%% rectangular range of initial conditions
phi0 = XXX;   % <<<<< choose wisely, based on (a). See assignment text
p0 = XXX;     % <<<<<
Deltaphi = XXX; % <<<<<
Deltap = XXX;   % <<<<<

inip = p0 + Deltap*(rand(Ntrajectories,1) - 0.5);
iniphi = phi0 + Deltaphi*(rand(Ntrajectories,1) - 0.5);

end %if

%%%%%%%%%%%%%%%%%%%

vars_out = zeros(Nsamples,2,Ntrajectories);

for nn = 1:Ntrajectories,

%allocate initial conditions
p0 = inip(nn);
phi0 = iniphi(nn);

% standard matlab differential equation solver:
display(['Solving trajectory ',num2str(nn)])
options = odeset('RelTol',1e-8,'AbsTol',1e-6,'Stats','off','InitialStep',tfin*1e-5);
[tout,vars_out(:,:,nn)] = ode45(@(t,xv)Newtons_equation(t,xv),tsamples,[p0 phi0],options);

end

save(['assignment6_output.mat'])
display(['Wrote assignment6_output.mat'])

%%%%%%%%%%%%%%%%%%%%%%%%
% internal functions
%%%%%%%%%%%%%%%%%%%%%%%%

function dvars_dt = Newtons_equation(t,xv_in)
 
dxv_dt = [42      % <<<<<
          23];    % <<<<<
 
end % funct

end % main function